<?php
namespace Teknisa\PLA\Modules\Mymenu\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use \Teknisa\Model\Geral\Entities\Lista;

class Mym00109AnalisePesquisaSatisfacaoService {

	protected $util;
    protected $dataSourceManager;
    protected $environment;
    protected $entityManager;
    protected $novoCodigo;
	
	public function __construct($util, $dataSourceManager, $environment, $entityManager, $novoCodigo) {
        $this->util = $util;
		$this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->entityManager = $entityManager;
		$this->novoCodigo = $novoCodigo;
	}

    public function geraLista($nrorg, $lista, $separador) {

        $lista = explode($separador, $lista);

        if ($lista[0]) {
            $nrlista = $this->novoCodigo->getCodeByTableName('LISTA', $nrorg);
            $sql = "INSERT INTO LISTA (CDLISTA, NRLISTA, NRORG) VALUES (:CDLISTA, :NRLISTA, :NRORG)";
            foreach ($lista as $item) {

                $stmt = $this->entityManager->getConnection()->prepare($sql);
                $stmt->execute(
                    array(
                        "CDLISTA" => $item,
                        "NRLISTA" => $nrlista,
                        "NRORG" => $nrorg
                    )
                );
            }
        } else {
            $nrlista = '0';
        } 
        
        
        return $nrlista;
    }

    public function deletaLista($nrorg, $nrlista) {
        $lista = $this->entityManager->getRepository('\Teknisa\Model\Geral\Entities\Lista')
            ->findBy(array('nrorg' => $nrorg, 'nrlista' => $nrlista));

        $this->entityManager->getConnection()->beginTransaction();

        foreach ($lista as $registro) {
            $this->entityManager->remove($registro);
            $this->entityManager->flush();
        }

        $this->entityManager->getConnection()->commit();

        return true;
    }
}